{
ZZZZZZ 5.0, a chess program.
Copyright (C) 1998 G. Wiesenekker
E-mail: gijsbert.wiesenekker@wxs.nl
http://home.wxs.nl/~gijsbert.wiesenekker

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
}
unit Chess;

{$MODE Delphi}

interface

uses
  LCLIntf, LCLType, LMessages, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, Menus, Rand;

const
	wP = 'a';
  wN = 'b';
  wB = 'c';
  wR = 'd';
  wQ = 'e';
  wK = 'f';
  bP = 'g';
  bN = 'h';
  bB = 'i';
  bR = 'j';
  bQ = 'k';
  bK = 'l';
 	nE = 'm';
  A8 = 27;
  B8 = A8 + 1;
  C8 = B8 + 1;
  D8 = C8 + 1;
  E8 = D8 + 1;
  F8 = E8 + 1;
  G8 = F8 + 1;
  H8 = G8 + 1;
  A7 = A8 + 12;
  B7 = B8 + 12;
  C7 = C8 + 12;
  D7 = D8 + 12;
  E7 = E8 + 12;
  F7 = F8 + 12;
  G7 = G8 + 12;
  H7 = H8 + 12;
  A6 = A7 + 12;
  B6 = B7 + 12;
  C6 = C7 + 12;
  D6 = D7 + 12;
  E6 = E7 + 12;
  F6 = F7 + 12;
  G6 = G7 + 12;
  H6 = H7 + 12;
  A5 = A6 + 12;
  B5 = B6 + 12;
  C5 = C6 + 12;
  D5 = D6 + 12;
  E5 = E6 + 12;
  F5 = F6 + 12;
  G5 = G6 + 12;
  H5 = H6 + 12;
  A4 = A5 + 12;
  B4 = B5 + 12;
  C4 = C5 + 12;
  D4 = D5 + 12;
  E4 = E5 + 12;
  F4 = F5 + 12;
  G4 = G5 + 12;
  H4 = H5 + 12;
  A3 = A4 + 12;
  B3 = B4 + 12;
  C3 = C4 + 12;
  D3 = D4 + 12;
  E3 = E4 + 12;
  F3 = F4 + 12;
  G3 = G4 + 12;
  H3 = H4 + 12;
  A2 = A3 + 12;
  B2 = B3 + 12;
  C2 = C3 + 12;
  D2 = D3 + 12;
  E2 = E3 + 12;
  F2 = F3 + 12;
  G2 = G3 + 12;
  H2 = H3 + 12;
  A1 = A2 + 12;
  B1 = B2 + 12;
  C1 = C2 + 12;
  D1 = D2 + 12;
  E1 = E2 + 12;
  F1 = F2 + 12;
  G1 = G2 + 12;
  H1 = H2 + 12;
  RegKeyZZZZZZ = 'SOFTWARE\ZZZZZZ 5.0';
  RegValVersion = 'Version';
  RegValFontSize = 'Font Size (Points)';
  RegValDebug = 'Debug';
  RegValCacheSize = 'Cache Size (Mb)';
  RegValQuiesCacheSize = 'Quies Cache Size (Mb)';
  RegValScoreCacheSize = 'Score Cache Size (Mb)';
  RegValPawnValue = 'Value of Pawn';
  RegValKnightValue = 'Value of Knight';
  RegValBishopValue = 'Value of Bishop';
  RegValRookValue = 'Value of Rook';
  RegValQueenValue = 'Value of Queen';
  RegValTimeLimit = 'Time Limit';
  RegValDepthLimit = 'Depth Limit';
  RegValDoublePawnScore = 'Double pawn score';
  RegValIsolatedPawnScore = 'Isolated pawn score';
  RegValBishopPairScore = 'Bishop pair score';
  RegValKnightStrongScore = 'Strong knight score';
  RegValBishopStrongScore = 'Strong bishop score';
  RegValBishopBlocksPawnScore = 'Bishop blocks pawn score';
  RegValBishopLowMobilityScore = 'Bishop low mobility';
  RegValRookHalfOpenFileScore = 'Rook on half open file score';
  RegValRookOpenFileScore = 'Rook on open file score';
  RegValRook7thRankScore = 'Rook on 7th rank score';
  RegValWeakPinScore = 'Weak pin score';
  RegValStrongPinScore = 'Strong pin score';
  RegValKnightWeakScore = 'Knight weak score';
  RegValBishopWeakScore = 'Bishop weak score';
  RegValRookWeakScore = 'Rook weak score';
  RegValQueenWeakScore = 'Queen weak score';
  RegValKingWeakScore = 'King weak score';
  RegValKingShortCastledScore = 'King short castled score';
  RegValKingLongCastledScore = 'King long castled score';
  RegValKingLostCastlingRightsScore = 'King lost castling rights score';
  RegValKingOpenFileScore = 'King on open file score';
  RegValGameMovesFirstPeriod = 'Moves first period';
  RegValGameTimeFirstPeriod = 'Time first period (min)';
  RegValGameMovesSecondPeriod = 'Moves second period';
  RegValGameTimeSecondPeriod = 'Time second period (min)';
  RegValPawnExchangeScore = 'Pawn exchange score';
  RegValQueenExchangeScore = 'Queen exchange score';
  RegValWhiteBackGroundColor = 'White square color';
  RegValBlackBackGroundColor = 'Black square color';
  BoardMax = 144;
  ListMax = 16;
  TargetMax = 27;
  MovesMax = 200;
  NodesMax = 1000;
type
	EChessError = class(Exception);
  ExtBoardRange = 0..BoardMax;
  BoardRange = 1..BoardMax;
  ExtBoardColourEnum = (White, Black, None);
  BoardColourEnum = White..Black;
  ExtBoardKindEnum = (Pawn, Knight, Bishop, Rook, Queen, King, Empty, Side);
  BoardKindEnum = Pawn..King;
  CastlingRightsEnum = (WhiteShort, WhiteLong, BlackShort, BlackLong);
  CheckEnum = (Check, NoCheck, CheckUnknown);
  MovesEnum = (AllMoves, CapturesOnly);
  FileRange = 1..8;
  ExtFileRange = 0..8;
  RankRange = 1..8;
  ExtRankRange = 0..8;
  //
  ListRange = 1..ListMax;
  ExtListRange = 0..ListMax;
	//
  KeyArray = array[BoardRange] of Key;
  MaterialArray = array[BoardColourEnum] of Integer;
  ListRecord = record
  	ListColour: ExtBoardColourEnum;
  	ListKind: ExtBoardKindEnum;
  	ListWhere: ExtBoardRange;
    ListMoved: Boolean;
    ListCaptured: Boolean;
  	ListKey: ^KeyArray;
  end;
  ListRecordPointer = ^ListRecord;
  MoveRange = 1..MovesMax;
  ExtMoveRange = 0..MovesMax;
  MoveKindEnum = (Normal, Capture, ShortCastle, LongCastle, EnPassant, DoublePawn,
  	Promotion, PromotionKnight, PromotionBishop, PromotionRook, PromotionQueen, Null, Invalid);
  MoveKindSet = set of MoveKindEnum;
  MoveRecord = record
  	case Boolean of
    	False: (MoveFrom, MoveTo: BoardRange; MoveKind: MoveKindSet);
      True: (AllFields: Integer);
  end;
  MoveList = array[MoveRange] of MoveRecord;
  //
  ExtNodeRange = 0..NodesMax;
  NodeRange = 1..NodesMax;
  NodeRecord = record
  	NodeHashKey: Key;
    NodeMaterialScore: MaterialArray;
    NodeFullHashKey: Key;
    NodeCapture: Boolean;
    ThePromotion, TheCapture: ListRecordPointer;
    NodeListMoved, NodeListCaptured: Boolean;
    NodeEnPassant: ExtBoardRange;
    NodeNull: Boolean;
  end;
  BoardGridType = array [0..7, 0..7] of AnsiString;
	//
	ScoreRecord = record
		MatScore: Integer;
    PosScore: Integer;
    VisitScore: Integer;
  end;
  Operator = (LT, LE, EQ, GE, GT);
  CacheKindEnum = (LowerBound, UpperBound, TrueScore);
  CacheRecord = record
  	CacheKey: Key;
    CacheScore: ScoreRecord;
    CacheKind: CacheKindEnum;
    CacheDepth: Integer;
    CacheBestMove: MoveRecord;
  end;
  CacheArray = array of CacheRecord;
  QuiesCacheRecord = record
  	QuiesCacheKey: Key;
    QuiesBestMove: MoveRecord;
{$IFDEF TraceScore}
    QuiesCacheScore: ScoreRecord;
{$ENDIF}
  end;
  QuiesCacheArray = array of QuiesCacheRecord;
  ScoreCacheRecord = record
  	ScoreCacheKey: Key;
    ScoreCacheScore: ScoreRecord;
  end;
  ScoreCacheArray = array of ScoreCacheRecord;
  OptionsRecord = record
  	UseCache: Boolean;
    UseNullMove: Boolean;
    UseLazy: Boolean;
    ExtendCheck: Boolean;
    UseSounds: Boolean;
    TimeLimit: Integer;
    DepthLimit: Integer;
  end;
	DirRange = 1..8;
	DirArray = array [DirRange] of Integer;
  GameModeEnum = (HumanHuman, HumanComputer, ComputerHuman, ComputerComputer, NoSearch);
	PlayerEnum = (Human, Computer);
var
  Debug: Boolean;
  Options: OptionsRecord;
  ShowScore: Boolean;
	FontSize: Integer;
  CacheSize, QuiesCacheSize, ScoreCacheSize: Integer;
  Board: array[BoardRange] of ListRecordPointer;
  HashKey: Key;
  WhiteShortCastleKey, WhiteLongCastleKey: Key;
  BlackShortCastleKey, BlackLongCastleKey: Key;
  EnPassantKey: KeyArray;
  CastlingRights: set of CastlingRightsEnum;
  MaterialScore: MaterialArray;
  PieceCount: array[BoardColourEnum, BoardKindEnum] of ExtListRange;
	PieceList: array[BoardColourEnum, BoardKindEnum, ListRange] of ListRecord;
  NodeList: array[NodeRange] of NodeRecord;
  Node: ExtNodeRange;
  GameBoardGrid: BoardGridType;
  GameColour: BoardColourEnum;
  GameMode: GameModeEnum;
  GameMovesFirstPeriod: Integer;
  GameTimeFirstPeriod: Integer;
  GameMovesSecondPeriod: Integer;
  GameTimeSecondPeriod: Integer;
  GameTimeUsed: Integer;
  //Cache seems to be a reserved word..
  AlphaBetaCache: array[BoardColourEnum] of CacheArray;
  QuiesCache: array[BoardColourEnum] of QuiesCacheArray;
  ScoreCache: array[BoardColourEnum] of ScoreCacheArray;
	TimeSearch, TimeProblem: Integer;
  WhiteBackGroundColor, BlackBackGroundColor: TColor;
const
	PawnMoveDir: array [BoardColourEnum] of Integer = (-12, 12);
	PawnCaptureDir1: array[BoardColourEnum] of Integer = (-11, 11);
	PawnCaptureDir2: array[BoardColourEnum] of Integer = (-13, 13);
	KnightDir: DirArray = (-25, -23, -14, -10, 10, 14, 23, 25);
	BishopDir: DirArray = (-13, -11, 11, 13, 0, 0, 0, 0);
	RookDir: DirArray = (-12, -1, 1, 12, 0, 0, 0, 0);
	QueenDir: DirArray = (-13, -12, -11, -1, 1, 11, 12, 13);
	KingDir: DirArray = (-13, -12, -11, -1, 1, 11, 12, 13);
	ExtBoardKindToString: array[ExtBoardKindEnum] of Char =
  	('P', 'N', 'B', 'R', 'Q', 'K', 'N', 'E');
	ExtBoardColourToString: array[ExtBoardColourEnum] of Char =
  	('w', 'b', 'n');
	EmptySquare: ListRecord = (ListColour: None;
  	ListKind: Empty;
    ListWhere: Low(ExtBoardRange);
    ListMoved: True;
    ListCaptured: False;
    ListKey: nil);
	SideSquare: ListRecord = (ListColour: None;
  	ListKind: Side;
  	ListWhere: Low(ExtBoardRange);
    ListMoved: True;
    ListCaptured: False;
    ListKey: nil);
  FileNumber: array[BoardRange] of ExtFileRange =
  	(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  	 0, 0, 1, 2, 3, 4, 5, 6, 7, 8, 0, 0,
  	 0, 0, 1, 2, 3, 4, 5, 6, 7, 8, 0, 0,
  	 0, 0, 1, 2, 3, 4, 5, 6, 7, 8, 0, 0,
  	 0, 0, 1, 2, 3, 4, 5, 6, 7, 8, 0, 0,
  	 0, 0, 1, 2, 3, 4, 5, 6, 7, 8, 0, 0,
  	 0, 0, 1, 2, 3, 4, 5, 6, 7, 8, 0, 0,
  	 0, 0, 1, 2, 3, 4, 5, 6, 7, 8, 0, 0,
  	 0, 0, 1, 2, 3, 4, 5, 6, 7, 8, 0, 0,
  	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
 	RankNumber: array[BoardColourEnum, BoardRange] of ExtRankRange =
  	((0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  	  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  	  0, 0, 8, 8, 8, 8, 8, 8, 8, 8, 0, 0,
  	  0, 0, 7, 7, 7, 7, 7, 7, 7, 7, 0, 0,
  	  0, 0, 6, 6, 6, 6, 6, 6, 6, 6, 0, 0,
  	  0, 0, 5, 5, 5, 5, 5, 5, 5, 5, 0, 0,
  	  0, 0, 4, 4, 4, 4, 4, 4, 4, 4, 0, 0,
  	  0, 0, 3, 3, 3, 3, 3, 3, 3, 3, 0, 0,
  	  0, 0, 2, 2, 2, 2, 2, 2, 2, 2, 0, 0,
  	  0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0,
  	  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  	  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0),
  	 (0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  	  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  	  0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0,
  	  0, 0, 2, 2, 2, 2, 2, 2, 2, 2, 0, 0,
  	  0, 0, 3, 3, 3, 3, 3, 3, 3, 3, 0, 0,
  	  0, 0, 4, 4, 4, 4, 4, 4, 4, 4, 0, 0,
  	  0, 0, 5, 5, 5, 5, 5, 5, 5, 5, 0, 0,
  	  0, 0, 6, 6, 6, 6, 6, 6, 6, 6, 0, 0,
  	  0, 0, 7, 7, 7, 7, 7, 7, 7, 7, 0, 0,
  	  0, 0, 8, 8, 8, 8, 8, 8, 8, 8, 0, 0,
  	  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  	  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0));
	RowColToBoardIndex: array [0..7, 0..7] of BoardRange =
  	((A8, B8, C8, D8, E8, F8, G8, H8),
     (A7, B7, C7, D7, E7, F7, G7, H7),
     (A6, B6, C6, D6, E6, F6, G6, H6),
     (A5, B5, C5, D5, E5, F5, G5, H5),
     (A4, B4, C4, D4, E4, F4, G4, H4),
     (A3, B3, C3, D3, E3, F3, G3, H3),
     (A2, B2, C2, D2, E2, F2, G2, H2),
     (A1, B1, C1, D1, E1, F1, G1, H1));
	LinearToBoardIndex: array [1..64] of BoardRange =
  	(A8, B8, C8, D8, E8, F8, G8, H8,
     A7, B7, C7, D7, E7, F7, G7, H7,
     A6, B6, C6, D6, E6, F6, G6, H6,
     A5, B5, C5, D5, E5, F5, G5, H5,
     A4, B4, C4, D4, E4, F4, G4, H4,
     A3, B3, C3, D3, E3, F3, G3, H3,
     A2, B2, C2, D2, E2, F2, G2, H2,
     A1, B1, C1, D1, E1, F1, G1, H1);
	InvLinearToBoardIndex: array [1..64] of BoardRange =
  	(A1, B1, C1, D1, E1, F1, G1, H1,
     A2, B2, C2, D2, E2, F2, G2, H2,
     A3, B3, C3, D3, E3, F3, G3, H3,
     A4, B4, C4, D4, E4, F4, G4, H4,
     A5, B5, C5, D5, E5, F5, G5, H5,
     A6, B6, C6, D6, E6, F6, G6, H6,
     A7, B7, C7, D7, E7, F7, G7, H7,
  	 A8, B8, C8, D8, E8, F8, G8, H8);
	StartBoardGrid: BoardGridType =
  	((bR, bN, bB, bQ, bK, bB, bN, bR),
     (bP, bP, bP, bP, bP, bP, bP, bP),
     (nE, nE, nE, nE, nE, nE, nE, nE),
     (nE, nE, nE, nE, nE, nE, nE, nE),
     (nE, nE, nE, nE, nE, nE, nE, nE),
     (nE, nE, nE, nE, nE, nE, nE, nE),
     (wP, wP, wP, wP, wP, wP, wP, wP),
  	 (wR, wN, wB, wQ, wK, wB, wN, wR));

function BoardIndexToExtCol(i: BoardRange): Integer;
function BoardIndexToExtRow(i: BoardRange): Integer;
function BoardIndexToString(i: BoardRange): AnsiString;
function ColourToString(iColour: BoardColourEnum): AnsiString;

implementation

function BoardIndexToExtCol(i: BoardRange): Integer;
begin
	Result := (i - 1) mod 12;
end;

function BoardIndexToExtRow(i: BoardRange): Integer;
begin
	Result := (i - 1) div 12;
end;

function BoardIndexToString(i: BoardRange): AnsiString;
var
	Col, Row: Integer;
const
	ColToChar: array[2..9] of Char = ('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h');
  RowToChar: array[2..9] of Char = ('8', '7', '6', '5', '4', '3', '2', '1');
begin
	Col := BoardIndexToExtCol(i);
  Row := BoardIndexToExtRow(i);
  Result := ColToChar[Col] + RowToChar[Row];
end;

function ColourToString(iColour: BoardColourEnum): AnsiString;
begin
	if iColour = White then
  	Result := 'white'
  else if iColour = Black then
  	Result := 'black'
  else
    Result := '?colour?';
end;

procedure CheckAlignment;
var
	Move1, Move2: MoveRecord;
  procedure CompareMoves;
  begin
    if Move2.MoveFrom <> Move1.MoveFrom then
      raise EChessError.Create('Alignment error');
    if Move2.MoveTo <> Move1.MoveTo then
      raise EChessError.Create('Alignment error');
    if Move2.MoveKind <> Move1.MoveKind then
      raise EChessError.Create('Alignment error');
  end;
begin
	Move1.MoveFrom := A1;
  Move1.MoveTo := H8;
  Move1.MoveKind := [Normal];
  Move2.AllFields := Move1.AllFields;
  CompareMoves;
	Move2.MoveFrom := H1;
  Move2.MoveTo := A8;
  Move2.MoveKind := [Capture];
  Move1.AllFields := Move2.AllFields;
  CompareMoves;
end;

initialization

CheckAlignment;

end.
