unit DebugBoard;

{$MODE Delphi}

interface

uses
  LCLIntf, LCLType, LMessages, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids;

type
  TDebugBoardForm = class(TForm)
    BoardGrid: TStringGrid;
    OkButton: TButton;
    procedure FormShow(Sender: TObject);
    procedure BoardGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DebugBoardForm: TDebugBoardForm;

implementation

uses Chess, Main, Utils;

{$R *.lfm}

procedure DrawBoard;
var
	Col, Row: Integer;
  DrawCol, DrawRow: Integer;
  Map: AnsiString;
begin
	for Col := 0 to 7 do
  begin
  	for Row := 0 to 7 do
    begin
    	with Board[RowColToBoardIndex[Row, Col]]^ do
      begin
      	if ListColour = White then
        begin
        	if ListKind = Pawn then
          	Map := wP
        	else if ListKind = Knight then
          	Map := wN
        	else if ListKind = Bishop then
          	Map := wB
        	else if ListKind = Rook then
          	Map := wR
        	else if ListKind = Queen then
          	Map := wQ
        	else if ListKind = King then
          	Map := wK
          else
          	raise EChessError.Create('ListKind Error');
        end
        else if ListColour = Black then
        begin
        	if ListKind = Pawn then
          	Map := bP
        	else if ListKind = Knight then
          	Map := bN
        	else if ListKind = Bishop then
          	Map := bB
        	else if ListKind = Rook then
          	Map := bR
        	else if ListKind = Queen then
          	Map := bQ
        	else if ListKind = King then
          	Map := bK
          else
          	raise EChessError.Create('ListKind Error');
        end
        else
        	Map := nE;
        if ListCaptured then
        	Map := Map + '*';
        if MainForm.InvertBoardItem.Checked then
        begin
        	DrawCol := 7 - Col;
          DrawRow := 7 - Row;
        end
        else
        begin
        	DrawCol := Col;
          DrawRow := Row;
        end;
        if Map <> DebugBoardForm.BoardGrid.Cells[DrawCol, DrawRow] then
        	DebugBoardForm.BoardGrid.Cells[DrawCol, DrawRow] := Map;
    	end;
    end;
  end;
end;

procedure TDebugBoardForm.FormShow(Sender: TObject);
begin
	DrawBoard;
end;

procedure TDebugBoardForm.BoardGridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
begin
	StringGridDrawCell(BoardGrid, ACol, ARow, Rect, State);
end;

end.
