{
ZZZZZZ 5.0, a chess program.
Copyright (C) 1998 G. Wiesenekker
E-mail: gijsbert.wiesenekker@wxs.nl
http://home.wxs.nl/~gijsbert.wiesenekker

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
}
unit DebugLists;

{$MODE Delphi}

interface

uses
  LCLIntf, LCLType, LMessages, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls;

type
  TDebugListsForm = class(TForm)
    BoardGrid: TStringGrid;
    WhiteListGrid: TStringGrid;
    BlackListGrid: TStringGrid;
    OkButton: TButton;
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DebugListsForm: TDebugListsForm;

implementation

{$R *.lfm}

uses Chess, Utils;

procedure TDebugListsForm.FormShow(Sender: TObject);
var
	i: BoardRange;
  Info: AnsiString;
  Colour: BoardColourEnum;
  Kind: BoardKindEnum;
  Row: Integer;
  List: ExtListRange;
	ListGrid: array[BoardColourEnum] of TStringGrid;
begin
  for i := 1 to High(BoardRange) do
  begin
  	with Board[i]^ do
    begin
      Info := ' ' + ExtBoardColourToString[ListColour] +
      	ExtBoardKindToString[ListKind];
      if not ListMoved then
      	Info := Info + '*';
      BoardGrid.Cells[BoardIndexToExtCol(i), BoardIndexToExtRow(i)] := Info;
    end;
  end;
 	ClearStringGrid(WhiteListGrid);
 	ClearStringGrid(BlackListGrid);
	WhiteListGrid.Cells[0, 0] := 'White';
	BlackListGrid.Cells[0, 0] := 'Black';
  ListGrid[White] := WhiteListGrid;
  ListGrid[Black] := BlackListGrid;
  for Colour := White to Black do
  begin
  	ListGrid[Colour].Cells[1, 0] := 'Kind';
    ListGrid[Colour].Cells[2, 0] := 'Where';
  	Row := 0;
		for Kind := Pawn to King do
  	begin
    	for List := 1 to PieceCount[Colour, Kind] do
      begin
      	with PieceList[Colour, Kind, List] do
        begin
        	Inc(Row);
        	ListGrid[Colour].Cells[0, Row] := IntToStr(Row);
        	ListGrid[Colour].Cells[1, Row] := ExtBoardKindToString[ListKind];
        	ListGrid[Colour].Cells[2, Row] := BoardIndexToString(ListWhere);
      	end;
      end;
  	end;
  end;
end;

end.
