{
ZZZZZZ 5.0, a chess program.
Copyright (C) 1998 G. Wiesenekker
E-mail: gijsbert.wiesenekker@wxs.nl
http://home.wxs.nl/~gijsbert.wiesenekker

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
}
unit DebugRand;

{$MODE Delphi}

interface

uses
  LCLIntf, LCLType, LMessages, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TDebugRandForm = class(TForm)
    FreqButton: TButton;
    PlotButton: TButton;
    ClearButton: TButton;
    procedure FreqButtonClick(Sender: TObject);
    procedure PlotButtonClick(Sender: TObject);
    procedure ClearButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DebugRandForm: TDebugRandForm;

implementation

{$R *.lfm}

uses Chess, Rand;

procedure TDebugRandForm.FreqButtonClick(Sender: TObject);
var
  F: array[0..63] of Integer;
  i, n: Integer;
	K: Key;
  X, Y: Integer;
label
	return;
begin
	Screen.Cursor := crHourGlass;
	for i := 0 to 63 do
  	F[i] := 0;
  Canvas.MoveTo(0, 64);
  Canvas.LineTo(509, 64);
  //on average half of the bits will be 1's
	for n := 1 to 2 * 509 do
  begin
  	K := GenKey;
    for i := 0 to 63 do
    begin
			if ((K and (Int64(1) shl i)) <> 0) then
      begin
      	Inc(F[i]);
        if (F[i] = 509) then goto return;
        X := F[i];
        Y := i;
      	DebugRandForm.Canvas.MoveTo(X, Y);
      	DebugRandForm.Canvas.LineTo(X + 1, Y);
      end;
    end;
  end;
	return:
  Screen.Cursor := crDefault;
end;

procedure TDebugRandForm.PlotButtonClick(Sender: TObject);
var
	i, j: Integer;
  X, Y: Integer;
begin
	Screen.Cursor := crHourGlass;
  for i := 1 to 509 do
  begin
  	for j := 1 to 509 do
    begin
    	X := GenKey mod 509;
      Y := GenKey mod 509;
      DebugRandForm.CanVas.MoveTo(X, Y);
      DebugRandForm.Canvas.LineTo(X + 1, Y + 1);
    end;
  end;
	Screen.Cursor := crDefault;
end;

procedure TDebugRandForm.ClearButtonClick(Sender: TObject);
var
	Rect: TRect;
begin
	Rect.Left := 0;
  Rect.Right := DebugRandForm.Width;
  Rect.Top := 0;
  Rect.Bottom := DebugRandForm.Height;
  Canvas.Brush.Color := DebugRandForm.Color;
	Canvas.FillRect(Rect);
end;

end.
