{
ZZZZZZ 5.0, a chess program.
Copyright (C) 1998 G. Wiesenekker
E-mail: gijsbert.wiesenekker@wxs.nl
http://home.wxs.nl/~gijsbert.wiesenekker

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
}
unit Parameters;

{$MODE Delphi}

interface

uses
  LCLIntf, LCLType, LMessages, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TParametersForm = class(TForm)
    OkButton: TButton;
    CancelButton: TButton;
    MaterialGroupBox: TGroupBox;
    PawnValueEdit: TEdit;
    KnightValueEdit: TEdit;
    BishopValueEdit: TEdit;
    RookValueEdit: TEdit;
    QueenValueEdit: TEdit;
    PawnLabel: TLabel;
    KnightLabel: TLabel;
    BishopLabel: TLabel;
    RookLabel: TLabel;
    QueenLabel: TLabel;
    SymmetricGroupBox: TGroupBox;
    BishopPairLabel: TLabel;
    RookOpenFileLabel: TLabel;
    Rook7thRankLabel: TLabel;
    BishopPairEdit: TEdit;
    RookOpenFileEdit: TEdit;
    Rook7thRankEdit: TEdit;
    StrongBishopLabel: TLabel;
    StrongKnightLabel: TLabel;
    KnightStrongEdit: TEdit;
    BishopStrongEdit: TEdit;
    DoublePawnLabel: TLabel;
    DoublePawnEdit: TEdit;
    WeakPinLabel: TLabel;
    WeakPinEdit: TEdit;
    StrongPinLabel: TLabel;
    StrongPinEdit: TEdit;
    KnightWeakLabel: TLabel;
    BishopWeakLabel: TLabel;
    RookWeakLabel: TLabel;
    QueenWeakLabel: TLabel;
    KingWeakLabel: TLabel;
    KnightWeakEdit: TEdit;
    BishopWeakEdit: TEdit;
    RookWeakEdit: TEdit;
    QueenWeakEdit: TEdit;
    KingWeakEdit: TEdit;
    BishopBlocksPawnEdit: TEdit;
    BishopBlocksPawnLabel: TLabel;
    IsolatedPawnLabel: TLabel;
    IsolatedPawnEdit: TEdit;
    KingOpenFileLabel: TLabel;
    KingOpenFileEdit: TEdit;
    CastlingRightsLabel: TLabel;
    KingLostCastlingRightsEdit: TEdit;
    KingShortCastledEdit: TEdit;
    BishopLowMobilityLabel: TLabel;
    KingShortCastledLabel: TLabel;
    AsymmetricGroupBox: TGroupBox;
    QueenExchangeLabel: TLabel;
    QueenExchangeEdit: TEdit;
    PawnExchange: TLabel;
    PawnExchangeEdit: TEdit;
    RookHalfOpenFileEdit: TEdit;
    RookHalfOpenFileLabel: TLabel;
    KingLongCastledLabel: TLabel;
    KingLongCastledEdit: TEdit;
    BishopLowMobilityEdit: TEdit;
    procedure FormShow(Sender: TObject);
    procedure OkButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ParametersForm: TParametersForm;

implementation

uses Utils, Chess, Score;

{$R *.lfm}

procedure TParametersForm.FormShow(Sender: TObject);
begin
	PawnValueEdit.Text := IntToStr(MaterialValue[Pawn]);
	KnightValueEdit.Text := IntToStr(MaterialValue[Knight]);
	BishopValueEdit.Text := IntToStr(MaterialValue[Bishop]);
	RookValueEdit.Text := IntToStr(MaterialValue[Rook]);
	QueenValueEdit.Text := IntToStr(MaterialValue[Queen]);
  //
  DoublePawnEdit.Text := IntToStr(DoublePawnScore);
  IsolatedPawnEdit.Text := IntToStr(IsolatedPawnScore);
  BishopPairEdit.Text := IntToStr(BishopPairScore);
  KnightStrongEdit.Text := IntToStr(KnightStrongScore);
  BishopStrongEdit.Text := IntToStr(BishopStrongScore);
  BishopBlocksPawnEdit.Text := IntToStr(BishopBlocksPawnScore);
  BishopLowMobilityEdit.Text := IntToStr(BishopLowMobilityScore);
  RookHalfOpenFileEdit.Text := IntToStr(RookHalfOpenFileScore);
  RookOpenFileEdit.Text := IntToStr(RookOpenFileScore);
  Rook7thRankEdit.Text := IntToStr(Rook7thRankScore);
  //
  WeakPinEdit.Text := IntToStr(WeakPinScore);
  StrongPinEdit.Text := IntToStr(StrongPinScore);
	//
  KnightWeakEdit.Text := IntToStr(KnightWeakScore);
  BishopWeakEdit.Text := IntToStr(BishopWeakScore);
  RookWeakEdit.Text := IntToStr(RookWeakScore);
  QueenWeakEdit.Text := IntToStr(QueenWeakScore);
  KingWeakEdit.Text := IntToStr(KingWeakScore);
  KingShortCastledEdit.Text := IntToStr(KingShortCastledScore);
  KingLongCastledEdit.Text := IntToStr(KingLongCastledScore);
  KingLostCastlingRightsEdit.Text := IntToStr(KingLostCastlingRightsScore);
  KingOpenFileEdit.Text := IntToStr(KingOpenFileScore);
  //
  PawnExchangeEdit.Text := IntToStr(PawnExchangeScore);
  QueenExchangeEdit.Text := IntToStr(QueenExchangeScore);
end;

procedure TParametersForm.OkButtonClick(Sender: TObject);

	procedure ShowConstraint(Constraint: AnsiString);
  begin
  	Application.MessageBox(PChar(Constraint), 'Constraint', MB_OK);
  end;
begin
	MaterialValue[Pawn] := StrToInt(PawnValueEdit.Text);
	MaterialValue[Knight] := StrToInt(KnightValueEdit.Text);
	MaterialValue[Bishop] := StrToInt(BishopValueEdit.Text);
	MaterialValue[Rook] := StrToInt(RookValueEdit.Text);
	MaterialValue[Queen] := StrToInt(QueenValueEdit.Text);
  //
  DoublePawnScore := StrToInt(DoublePawnEdit.Text);
  IsolatedPawnScore := StrToInt(IsolatedPawnEdit.Text);
  BishopPairScore := StrToInt(BishopPairEdit.Text);
  KnightStrongScore := StrToInt(KnightStrongEdit.Text);
  BishopStrongScore := StrToInt(BishopStrongEdit.Text);
  BishopBlocksPawnScore := StrToInt(BishopBlocksPawnEdit.Text);
  BishopLowMobilityScore := StrToInt(BishopLowMobilityEdit.Text);
  RookHalfOpenFileScore := StrToInt(RookHalfOpenFileEdit.Text);
  RookOpenFileScore := StrToInt(RookOpenFileEdit.Text);
  Rook7thRankScore := StrToInt(Rook7thRankEdit.Text);
  //
  WeakPinScore := StrToInt(WeakPinEdit.Text);
  StrongPinScore := StrToInt(StrongPinEdit.Text);
  //
  KnightWeakScore := StrToInt(KnightWeakEdit.Text);
  BishopWeakScore := StrToInt(BishopWeakEdit.Text);
  RookWeakScore := StrToInt(RookWeakEdit.Text);
  QueenWeakScore := StrToInt(QueenWeakEdit.Text);
  KingWeakScore := StrToInt(KingWeakEdit.Text);
  KingShortCastledScore := StrToInt(KingShortCastledEdit.Text);
  KingLongCastledScore := StrToInt(KingLongCastledEdit.Text);
  KingLostCastlingRightsScore := StrToInt(KingLostCastlingRightsEdit.Text);
  KingOpenFileScore := StrToInt(KingOpenFileEdit.Text);
  //
  PawnExchangeScore := StrToInt(PawnExchangeEdit.Text);
  QueenExchangeScore := StrToInt(QueenExchangeEdit.Text);
  //
  WriteRegValString(RegValPawnValue, IntToStr(MaterialValue[Pawn]));
  WriteRegValString(RegValKnightValue, IntToStr(MaterialValue[Knight]));
  WriteRegValString(RegValBishopValue, IntToStr(MaterialValue[Bishop]));
  WriteRegValString(RegValRookValue, IntToStr(MaterialValue[Rook]));
  WriteRegValString(RegValQueenValue, IntToStr(MaterialValue[Queen]));
  //
  WriteRegValString(RegValDoublePawnScore, IntToStr(DoublePawnScore));
  WriteRegValString(RegValIsolatedPawnScore, IntToStr(IsolatedPawnScore));
	WriteRegValString(RegValBishopPairScore, IntToStr(BishopPairScore));
  WriteRegValString(RegValKnightStrongScore, IntToStr(KnightStrongScore));
  WriteRegValString(RegValBishopStrongScore, IntToStr(BishopStrongScore));
  WriteRegValString(RegValBishopBlocksPawnScore, IntToStr(BishopBlocksPawnScore));
  WriteRegValString(RegValBishopLowMobilityScore, IntToStr(BishopLowMobilityScore));
  WriteRegValString(RegValRookHalfOpenFileScore, IntToStr(RookHalfOpenFileScore));
  WriteRegValString(RegValRookOpenFileScore, IntToStr(RookOpenFileScore));
  WriteRegValString(RegValRook7thRankScore, IntToStr(Rook7thRankScore));
  //
  WriteRegValString(RegValWeakPinScore, IntToStr(WeakPinScore));
  WriteRegValString(RegValStrongPinScore, IntToStr(StrongPinScore));
  //
  WriteRegValString(RegValKnightWeakScore, IntToStr(KnightWeakScore));
  WriteRegValString(RegValBishopWeakScore, IntToStr(BishopWeakScore));
  WriteRegValString(RegValRookWeakScore, IntToStr(RookWeakScore));
  WriteRegValString(RegValQueenWeakScore, IntToStr(QueenWeakScore));
  WriteRegValString(RegValKingWeakScore, IntToStr(KingWeakScore));
  WriteRegValString(RegValKingShortCastledScore, IntToStr(KingShortCastledScore));
  WriteRegValString(RegValKingLongCastledScore, IntToStr(KingLongCastledScore));
  WriteRegValString(RegValKingLostCastlingRightsScore, IntToStr(KingLostCastlingRightsScore));
  WriteRegValString(RegValKingOpenFileScore, IntToStr(KingOpenFileScore));
  //
  WriteRegValString(RegValPawnExchangeScore, IntToStr(PawnExchangeScore));
  WriteRegValString(RegValQueenExchangeScore, IntToStr(QueenExchangeScore));
  //
  //Constraints
  // if computer >= human
  //
  if (3 * MaterialValue[Pawn]) >= MaterialValue[Knight] then
  	ShowConstraint('will exchange a knight for 3 pawns');
  if (3 * MaterialValue[Pawn]) >= MaterialValue[Bishop] then
  	ShowConstraint('will exchange a bishop for 3 pawns');
  if (MaterialValue[Pawn] + MaterialValue[Rook]) >=
     (MaterialValue[Knight] + MaterialValue[Bishop]) then
  	ShowConstraint('will exchange a knight and bishop for a rook and a pawn');
  if MaterialValue[Queen] >= (2 * MaterialValue[Rook]) then
  	ShowConstraint('will exchange two rooks for a queen');
  if -BishopPairScore >= (DoublePawnScore + IsolatedPawnScore) then
  	ShowConstraint('will give up bishop pair a for double pawn and an isolated pawn');
end;

end.
