{
ZZZZZZ 5.0, a chess program.
Copyright (C) 1998 G. Wiesenekker
E-mail: gijsbert.wiesenekker@wxs.nl
http://home.wxs.nl/~gijsbert.wiesenekker

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
}
unit Settings;

{$MODE Delphi}

interface

uses
  LCLIntf, LCLType, LMessages, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TSettingsForm = class(TForm)
    OkButton: TButton;
    CancelButton: TButton;
    ModeRadioGroup: TRadioGroup;
    LimitsBox: TGroupBox;
    TimeLimitLabel: TLabel;
    DepthLimitLabel: TLabel;
    TimeLimitEdit: TEdit;
    DepthLimitEdit: TEdit;
    Label1: TLabel;
    GameMovesFirstPeriodEdit: TEdit;
    Label2: TLabel;
    GameTimeFirstPeriodEdit: TEdit;
    GameMovesSecondPeriodEdit: TEdit;
    Label3: TLabel;
    GameTimeSecondPeriodEdit: TEdit;
    Label4: TLabel;
    procedure FormShow(Sender: TObject);
    procedure OkButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SettingsForm: TSettingsForm;

implementation

uses Chess, Utils;

{$R *.lfm}

procedure TSettingsForm.FormShow(Sender: TObject);
begin
  TimeLimitEdit.Text := IntToStr(Options.TimeLimit);
  DepthLimitEdit.Text := IntToStr(Options.DepthLimit);
  //
  GameMovesFirstPeriodEdit.Text := IntToStr(GameMovesFirstPeriod);
  GameTimeFirstPeriodEdit.Text := IntToStr(GameTimeFirstPeriod);
  GameMovesSecondPeriodEdit.Text := IntToStr(GameMovesSecondPeriod);
  GameTimeSecondPeriodEdit.Text := IntToStr(GameTimeSecondPeriod);
	if GameMode = HumanHuman then
  	ModeRadioGroup.ItemIndex := 0
	else if GameMode = HumanComputer then
  	ModeRadioGroup.ItemIndex := 1
	else if GameMode = ComputerHuman then
  	ModeRadioGroup.ItemIndex := 2
  else if GameMode = ComputerComputer then
  	ModeRadioGroup.ItemIndex := 3
  else
  	ModeRadioGroup.ItemIndex := 4;
end;

procedure TSettingsForm.OkButtonClick(Sender: TObject);
begin
  Options.TimeLimit := StrToInt(TimeLimitEdit.Text);
  Options.DepthLimit := StrToInt(DepthLimitEdit.Text);
	//
  GameMovesFirstPeriod := StrToInt(GameMovesFirstPeriodEdit.Text);
  GameTimeFirstPeriod := StrToInt(GameTimeFirstPeriodEdit.Text);
  GameMovesSecondPeriod := StrToInt(GameMovesSecondPeriodEdit.Text);
  GameTimeSecondPeriod := StrToInt(GameTimeSecondPeriodEdit.Text);
  //
  WriteRegValString(RegValTimeLimit, IntToStr(Options.TimeLimit));
  WriteRegValString(RegValDepthLimit, IntToStr(Options.DepthLimit));
  //
  WriteRegValString(RegValGameMovesFirstPeriod, IntToStr(GameMovesFirstPeriod));
  WriteRegValString(RegValGameTimeFirstPeriod, IntToStr(GameTimeFirstPeriod));
  WriteRegValString(RegValGameMovesSecondPeriod, IntToStr(GameMovesSecondPeriod));
  WriteRegValString(RegValGameTimeSecondPeriod, IntToStr(GameTimeSecondPeriod));
	if ModeRadioGroup.ItemIndex = 0 then
  	GameMode := HumanHuman
  else if ModeRadioGroup.ItemIndex = 1 then
  	GameMode := HumanComputer
  else if ModeRadioGroup.ItemIndex = 2 then
  	GameMode := ComputerHuman
  else if ModeRadioGroup.ItemIndex = 3 then
  	GameMode := ComputerComputer
  else
  	GameMode := NoSearch;
end;

end.
